#include "deviceinfownd.h"
#include "devicestatuswnd.h"
#include <factory.h>
#include "graphwnd.h"
#include "graphwndtoolbar.h"
#include <objmodel.h>
#include "scopekey.h"
#include "scopewnd.h"
#include "sensorinfownd.h"
#include "sysmonwnd.h"

static CFactory theFactory;

const IFactory& getFactory() {
  return theFactory;
}

CFactory::~CFactory() {
  /* Nothing to do */
}

IDeviceInfoWnd*
CFactory::createDeviceInfoWnd(ISysMonWnd* pParent, bool_t bVisible) const
{
  return new CDeviceInfoWnd(pParent, bVisible);
}

IDeviceStatusWnd*
CFactory::createDeviceStatusWnd(ISysMonWnd* pParent, bool_t bVisible) const
{
  return new CDeviceStatusWnd(pParent, bVisible);
}

IGraphWnd*
CFactory::createGraphWnd(ISysMonWnd* pParent, unsigned int index, bool_t bVisible) const
{
  return new CGraphWnd(pParent, index, bVisible);
}

IGraphWndToolbar*
CFactory::createGraphWndToolbar(IGraphWnd* pParent, unsigned int index) const
{
  return new CGraphWndToolbar(pParent, index);
}

IScopeKey*
CFactory::createScopeKey(IGraphWndToolbar* pParent) const
{
  return new CScopeKey(pParent);
}

IScopeWnd*
CFactory::createScopeWnd(IGraphWnd* pParent) const
{
  return new CScopeWnd(pParent);
}

ISensorInfoWnd*
CFactory::createSensorInfoWnd(ISysMonWnd* pParent, bool_t bVisible) const
{
  return new CSensorInfoWnd(pParent, bVisible);
}

ISysMonWnd*
CFactory::createSysMonWnd() const
{
  return new CSysMonWnd();
}
